// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/sensu/sensu-go/api/core/v3/entity_config.proto

package v3

import (
	bytes "bytes"
	fmt "fmt"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/golang/protobuf/proto"
	v2 "github.com/sensu/sensu-go/api/core/v2"
	io "io"
	math "math"
	math_bits "math/bits"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// EntityConfig represents entity configuration.
type EntityConfig struct {
	// Metadata contains the name, namespace, labels and annotations of the
	// entity.
	Metadata *v2.ObjectMeta `protobuf:"bytes,1,opt,name=metadata,proto3" json:"metadata"`
	// EntityClass represents the class of the entity. It can be "agent",
	// "proxy", or "backend".
	EntityClass string `protobuf:"bytes,2,opt,name=entity_class,json=entityClass,proto3" json:"entity_class"`
	// User is the username the entity is connecting as, if the entity is an
	// agent entity.
	User string `protobuf:"bytes,3,opt,name=user,proto3" json:"user,omitempty"`
	// Subscriptions are a weak relationship between entities and checks. The
	// scheduler uses subscriptions to make entities to checks when scheduling.
	Subscriptions []string `protobuf:"bytes,4,rep,name=subscriptions,proto3" json:"subscriptions"`
	// Deregister, if true, will result in the entity being deleted when the
	// entity is an agent, and the agent disconnects its session.
	Deregister bool `protobuf:"varint,5,opt,name=deregister,proto3" json:"deregister"`
	// Deregistration contains configuration for Sensu entity de-registration.
	Deregistration v2.Deregistration `protobuf:"bytes,6,opt,name=deregistration,proto3" json:"deregistration"`
	// KeepaliveHandlers contains a list of handlers to use for the entity's
	// keepalive events.
	KeepaliveHandlers []string `protobuf:"bytes,7,rep,name=keepalive_handlers,json=keepaliveHandlers,proto3" json:"keepalive_handlers,omitempty"`
	// Redact contains the fields to redact on the entity, if the entity is an]
	// agent entity.
	Redact               []string `protobuf:"bytes,8,rep,name=redact,proto3" json:"redact,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *EntityConfig) Reset()         { *m = EntityConfig{} }
func (m *EntityConfig) String() string { return proto.CompactTextString(m) }
func (*EntityConfig) ProtoMessage()    {}
func (*EntityConfig) Descriptor() ([]byte, []int) {
	return fileDescriptor_8e130cbc0e37cbf4, []int{0}
}
func (m *EntityConfig) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *EntityConfig) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_EntityConfig.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *EntityConfig) XXX_Merge(src proto.Message) {
	xxx_messageInfo_EntityConfig.Merge(m, src)
}
func (m *EntityConfig) XXX_Size() int {
	return m.Size()
}
func (m *EntityConfig) XXX_DiscardUnknown() {
	xxx_messageInfo_EntityConfig.DiscardUnknown(m)
}

var xxx_messageInfo_EntityConfig proto.InternalMessageInfo

func (m *EntityConfig) GetMetadata() *v2.ObjectMeta {
	if m != nil {
		return m.Metadata
	}
	return nil
}

func (m *EntityConfig) GetEntityClass() string {
	if m != nil {
		return m.EntityClass
	}
	return ""
}

func (m *EntityConfig) GetUser() string {
	if m != nil {
		return m.User
	}
	return ""
}

func (m *EntityConfig) GetSubscriptions() []string {
	if m != nil {
		return m.Subscriptions
	}
	return nil
}

func (m *EntityConfig) GetDeregister() bool {
	if m != nil {
		return m.Deregister
	}
	return false
}

func (m *EntityConfig) GetDeregistration() v2.Deregistration {
	if m != nil {
		return m.Deregistration
	}
	return v2.Deregistration{}
}

func (m *EntityConfig) GetKeepaliveHandlers() []string {
	if m != nil {
		return m.KeepaliveHandlers
	}
	return nil
}

func (m *EntityConfig) GetRedact() []string {
	if m != nil {
		return m.Redact
	}
	return nil
}

func init() {
	proto.RegisterType((*EntityConfig)(nil), "sensu.core.v3.EntityConfig")
}

func init() {
	proto.RegisterFile("github.com/sensu/sensu-go/api/core/v3/entity_config.proto", fileDescriptor_8e130cbc0e37cbf4)
}

var fileDescriptor_8e130cbc0e37cbf4 = []byte{
	// 413 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x51, 0xbd, 0x8e, 0xd4, 0x30,
	0x18, 0x3c, 0xdf, 0x2e, 0xcb, 0x9e, 0xef, 0x47, 0x77, 0x2e, 0x90, 0x39, 0x89, 0x24, 0xa2, 0x4a,
	0x73, 0x0e, 0x97, 0x20, 0x21, 0x3a, 0x94, 0x03, 0x81, 0x84, 0x10, 0x52, 0x4a, 0x9a, 0x93, 0x93,
	0xf8, 0x72, 0x86, 0xdd, 0x38, 0xb2, 0x9d, 0x48, 0xbc, 0x09, 0x0d, 0x3d, 0x8f, 0xc0, 0x23, 0x6c,
	0xc9, 0x13, 0x44, 0x10, 0xba, 0x3c, 0x01, 0x25, 0x8a, 0xb3, 0xbb, 0x4a, 0xb6, 0xda, 0x26, 0x9a,
	0x99, 0x6f, 0x66, 0x62, 0x7f, 0x86, 0x2f, 0x33, 0xae, 0xef, 0xcb, 0x98, 0x24, 0x62, 0xe9, 0x29,
	0x96, 0xab, 0xb2, 0xff, 0x5e, 0x65, 0xc2, 0xa3, 0x05, 0xf7, 0x12, 0x21, 0x99, 0x57, 0x05, 0x1e,
	0xcb, 0x35, 0xd7, 0x5f, 0x6f, 0x13, 0x91, 0xdf, 0xf1, 0x8c, 0x14, 0x52, 0x68, 0x81, 0x4e, 0x8d,
	0x93, 0x74, 0x16, 0x52, 0x05, 0x97, 0xcf, 0x07, 0x4d, 0x99, 0xc8, 0x84, 0x67, 0x5c, 0x71, 0x79,
	0xf7, 0xaa, 0xba, 0x26, 0x01, 0xb9, 0x36, 0xa2, 0xd1, 0x0c, 0xea, 0x4b, 0x2e, 0x9f, 0xed, 0xf3,
	0x7f, 0xdf, 0x5b, 0x32, 0x4d, 0xd7, 0x09, 0x7f, 0xbf, 0x44, 0x7f, 0xe2, 0x3e, 0xf3, 0xf4, 0xfb,
	0x04, 0x9e, 0xbc, 0x31, 0xc2, 0x8d, 0xb9, 0x01, 0x7a, 0x0b, 0xe7, 0x5d, 0x65, 0x4a, 0x35, 0xc5,
	0xc0, 0x01, 0xee, 0xb1, 0xff, 0x98, 0x0c, 0xaf, 0xe3, 0x93, 0x8f, 0xf1, 0x67, 0x96, 0xe8, 0x0f,
	0x4c, 0xd3, 0xf0, 0x7c, 0x55, 0xdb, 0xa0, 0xad, 0xed, 0x6d, 0x24, 0xda, 0x22, 0x14, 0xc0, 0x93,
	0xcd, 0x6e, 0x16, 0x54, 0x29, 0x7c, 0xe8, 0x00, 0xf7, 0x28, 0x3c, 0x6f, 0x6b, 0x7b, 0xa4, 0x47,
	0xc7, 0x3d, 0xbb, 0xe9, 0x08, 0x42, 0x70, 0x5a, 0x2a, 0x26, 0xf1, 0xa4, 0x33, 0x47, 0x06, 0xa3,
	0x17, 0xf0, 0x54, 0x95, 0xb1, 0x4a, 0x24, 0x2f, 0x34, 0x17, 0xb9, 0xc2, 0x53, 0x67, 0xe2, 0x1e,
	0x85, 0x17, 0x6d, 0x6d, 0x8f, 0x07, 0xd1, 0x98, 0x22, 0x02, 0x61, 0xca, 0x24, 0xcb, 0xb8, 0xd2,
	0x4c, 0xe2, 0x07, 0x0e, 0x70, 0xe7, 0xe1, 0x59, 0x5b, 0xdb, 0x03, 0x35, 0x1a, 0x60, 0xf4, 0x1e,
	0x9e, 0x6d, 0x98, 0xa4, 0x5d, 0x05, 0x9e, 0x99, 0x05, 0x3c, 0xd9, 0x59, 0xc0, 0xeb, 0x91, 0x29,
	0x9c, 0xae, 0x6a, 0xfb, 0x20, 0xda, 0x89, 0xa2, 0x2b, 0x88, 0xbe, 0x30, 0x56, 0xd0, 0x05, 0xaf,
	0xd8, 0xed, 0x3d, 0xcd, 0xd3, 0x05, 0x93, 0x0a, 0x3f, 0xec, 0x8e, 0x1e, 0x5d, 0x6c, 0x27, 0xef,
	0xd6, 0x03, 0xf4, 0x08, 0xce, 0x24, 0x4b, 0x69, 0xa2, 0xf1, 0xdc, 0x58, 0xd6, 0x2c, 0x74, 0xfe,
	0xfd, 0xb1, 0xc0, 0x8f, 0xc6, 0x02, 0x3f, 0x1b, 0x0b, 0xac, 0x1a, 0x0b, 0xfc, 0x6a, 0x2c, 0xf0,
	0xbb, 0xb1, 0xc0, 0xb7, 0xbf, 0xd6, 0xc1, 0xa7, 0xc3, 0x2a, 0x88, 0x67, 0xe6, 0x21, 0x83, 0xff,
	0x01, 0x00, 0x00, 0xff, 0xff, 0xf5, 0x38, 0xd1, 0x8f, 0xb0, 0x02, 0x00, 0x00,
}

func (this *EntityConfig) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*EntityConfig)
	if !ok {
		that2, ok := that.(EntityConfig)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Metadata.Equal(that1.Metadata) {
		return false
	}
	if this.EntityClass != that1.EntityClass {
		return false
	}
	if this.User != that1.User {
		return false
	}
	if len(this.Subscriptions) != len(that1.Subscriptions) {
		return false
	}
	for i := range this.Subscriptions {
		if this.Subscriptions[i] != that1.Subscriptions[i] {
			return false
		}
	}
	if this.Deregister != that1.Deregister {
		return false
	}
	if !this.Deregistration.Equal(&that1.Deregistration) {
		return false
	}
	if len(this.KeepaliveHandlers) != len(that1.KeepaliveHandlers) {
		return false
	}
	for i := range this.KeepaliveHandlers {
		if this.KeepaliveHandlers[i] != that1.KeepaliveHandlers[i] {
			return false
		}
	}
	if len(this.Redact) != len(that1.Redact) {
		return false
	}
	for i := range this.Redact {
		if this.Redact[i] != that1.Redact[i] {
			return false
		}
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (m *EntityConfig) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *EntityConfig) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *EntityConfig) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.XXX_unrecognized != nil {
		i -= len(m.XXX_unrecognized)
		copy(dAtA[i:], m.XXX_unrecognized)
	}
	if len(m.Redact) > 0 {
		for iNdEx := len(m.Redact) - 1; iNdEx >= 0; iNdEx-- {
			i -= len(m.Redact[iNdEx])
			copy(dAtA[i:], m.Redact[iNdEx])
			i = encodeVarintEntityConfig(dAtA, i, uint64(len(m.Redact[iNdEx])))
			i--
			dAtA[i] = 0x42
		}
	}
	if len(m.KeepaliveHandlers) > 0 {
		for iNdEx := len(m.KeepaliveHandlers) - 1; iNdEx >= 0; iNdEx-- {
			i -= len(m.KeepaliveHandlers[iNdEx])
			copy(dAtA[i:], m.KeepaliveHandlers[iNdEx])
			i = encodeVarintEntityConfig(dAtA, i, uint64(len(m.KeepaliveHandlers[iNdEx])))
			i--
			dAtA[i] = 0x3a
		}
	}
	{
		size, err := m.Deregistration.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintEntityConfig(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x32
	if m.Deregister {
		i--
		if m.Deregister {
			dAtA[i] = 1
		} else {
			dAtA[i] = 0
		}
		i--
		dAtA[i] = 0x28
	}
	if len(m.Subscriptions) > 0 {
		for iNdEx := len(m.Subscriptions) - 1; iNdEx >= 0; iNdEx-- {
			i -= len(m.Subscriptions[iNdEx])
			copy(dAtA[i:], m.Subscriptions[iNdEx])
			i = encodeVarintEntityConfig(dAtA, i, uint64(len(m.Subscriptions[iNdEx])))
			i--
			dAtA[i] = 0x22
		}
	}
	if len(m.User) > 0 {
		i -= len(m.User)
		copy(dAtA[i:], m.User)
		i = encodeVarintEntityConfig(dAtA, i, uint64(len(m.User)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.EntityClass) > 0 {
		i -= len(m.EntityClass)
		copy(dAtA[i:], m.EntityClass)
		i = encodeVarintEntityConfig(dAtA, i, uint64(len(m.EntityClass)))
		i--
		dAtA[i] = 0x12
	}
	if m.Metadata != nil {
		{
			size, err := m.Metadata.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintEntityConfig(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func encodeVarintEntityConfig(dAtA []byte, offset int, v uint64) int {
	offset -= sovEntityConfig(v)
	base := offset
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return base
}
func NewPopulatedEntityConfig(r randyEntityConfig, easy bool) *EntityConfig {
	this := &EntityConfig{}
	if r.Intn(5) != 0 {
		this.Metadata = v2.NewPopulatedObjectMeta(r, easy)
	}
	this.EntityClass = string(randStringEntityConfig(r))
	this.User = string(randStringEntityConfig(r))
	v1 := r.Intn(10)
	this.Subscriptions = make([]string, v1)
	for i := 0; i < v1; i++ {
		this.Subscriptions[i] = string(randStringEntityConfig(r))
	}
	this.Deregister = bool(bool(r.Intn(2) == 0))
	v2 := v2.NewPopulatedDeregistration(r, easy)
	this.Deregistration = *v2
	v3 := r.Intn(10)
	this.KeepaliveHandlers = make([]string, v3)
	for i := 0; i < v3; i++ {
		this.KeepaliveHandlers[i] = string(randStringEntityConfig(r))
	}
	v4 := r.Intn(10)
	this.Redact = make([]string, v4)
	for i := 0; i < v4; i++ {
		this.Redact[i] = string(randStringEntityConfig(r))
	}
	if !easy && r.Intn(10) != 0 {
		this.XXX_unrecognized = randUnrecognizedEntityConfig(r, 9)
	}
	return this
}

type randyEntityConfig interface {
	Float32() float32
	Float64() float64
	Int63() int64
	Int31() int32
	Uint32() uint32
	Intn(n int) int
}

func randUTF8RuneEntityConfig(r randyEntityConfig) rune {
	ru := r.Intn(62)
	if ru < 10 {
		return rune(ru + 48)
	} else if ru < 36 {
		return rune(ru + 55)
	}
	return rune(ru + 61)
}
func randStringEntityConfig(r randyEntityConfig) string {
	v5 := r.Intn(100)
	tmps := make([]rune, v5)
	for i := 0; i < v5; i++ {
		tmps[i] = randUTF8RuneEntityConfig(r)
	}
	return string(tmps)
}
func randUnrecognizedEntityConfig(r randyEntityConfig, maxFieldNumber int) (dAtA []byte) {
	l := r.Intn(5)
	for i := 0; i < l; i++ {
		wire := r.Intn(4)
		if wire == 3 {
			wire = 5
		}
		fieldNumber := maxFieldNumber + r.Intn(100)
		dAtA = randFieldEntityConfig(dAtA, r, fieldNumber, wire)
	}
	return dAtA
}
func randFieldEntityConfig(dAtA []byte, r randyEntityConfig, fieldNumber int, wire int) []byte {
	key := uint32(fieldNumber)<<3 | uint32(wire)
	switch wire {
	case 0:
		dAtA = encodeVarintPopulateEntityConfig(dAtA, uint64(key))
		v6 := r.Int63()
		if r.Intn(2) == 0 {
			v6 *= -1
		}
		dAtA = encodeVarintPopulateEntityConfig(dAtA, uint64(v6))
	case 1:
		dAtA = encodeVarintPopulateEntityConfig(dAtA, uint64(key))
		dAtA = append(dAtA, byte(r.Intn(256)), byte(r.Intn(256)), byte(r.Intn(256)), byte(r.Intn(256)), byte(r.Intn(256)), byte(r.Intn(256)), byte(r.Intn(256)), byte(r.Intn(256)))
	case 2:
		dAtA = encodeVarintPopulateEntityConfig(dAtA, uint64(key))
		ll := r.Intn(100)
		dAtA = encodeVarintPopulateEntityConfig(dAtA, uint64(ll))
		for j := 0; j < ll; j++ {
			dAtA = append(dAtA, byte(r.Intn(256)))
		}
	default:
		dAtA = encodeVarintPopulateEntityConfig(dAtA, uint64(key))
		dAtA = append(dAtA, byte(r.Intn(256)), byte(r.Intn(256)), byte(r.Intn(256)), byte(r.Intn(256)))
	}
	return dAtA
}
func encodeVarintPopulateEntityConfig(dAtA []byte, v uint64) []byte {
	for v >= 1<<7 {
		dAtA = append(dAtA, uint8(uint64(v)&0x7f|0x80))
		v >>= 7
	}
	dAtA = append(dAtA, uint8(v))
	return dAtA
}
func (m *EntityConfig) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.Metadata != nil {
		l = m.Metadata.Size()
		n += 1 + l + sovEntityConfig(uint64(l))
	}
	l = len(m.EntityClass)
	if l > 0 {
		n += 1 + l + sovEntityConfig(uint64(l))
	}
	l = len(m.User)
	if l > 0 {
		n += 1 + l + sovEntityConfig(uint64(l))
	}
	if len(m.Subscriptions) > 0 {
		for _, s := range m.Subscriptions {
			l = len(s)
			n += 1 + l + sovEntityConfig(uint64(l))
		}
	}
	if m.Deregister {
		n += 2
	}
	l = m.Deregistration.Size()
	n += 1 + l + sovEntityConfig(uint64(l))
	if len(m.KeepaliveHandlers) > 0 {
		for _, s := range m.KeepaliveHandlers {
			l = len(s)
			n += 1 + l + sovEntityConfig(uint64(l))
		}
	}
	if len(m.Redact) > 0 {
		for _, s := range m.Redact {
			l = len(s)
			n += 1 + l + sovEntityConfig(uint64(l))
		}
	}
	if m.XXX_unrecognized != nil {
		n += len(m.XXX_unrecognized)
	}
	return n
}

func sovEntityConfig(x uint64) (n int) {
	return (math_bits.Len64(x|1) + 6) / 7
}
func sozEntityConfig(x uint64) (n int) {
	return sovEntityConfig(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (m *EntityConfig) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowEntityConfig
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: EntityConfig: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: EntityConfig: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Metadata", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthEntityConfig
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthEntityConfig
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.Metadata == nil {
				m.Metadata = &v2.ObjectMeta{}
			}
			if err := m.Metadata.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field EntityClass", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthEntityConfig
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthEntityConfig
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.EntityClass = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field User", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthEntityConfig
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthEntityConfig
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.User = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Subscriptions", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthEntityConfig
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthEntityConfig
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Subscriptions = append(m.Subscriptions, string(dAtA[iNdEx:postIndex]))
			iNdEx = postIndex
		case 5:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Deregister", wireType)
			}
			var v int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				v |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			m.Deregister = bool(v != 0)
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Deregistration", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthEntityConfig
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthEntityConfig
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Deregistration.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 7:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field KeepaliveHandlers", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthEntityConfig
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthEntityConfig
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.KeepaliveHandlers = append(m.KeepaliveHandlers, string(dAtA[iNdEx:postIndex]))
			iNdEx = postIndex
		case 8:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Redact", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthEntityConfig
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthEntityConfig
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Redact = append(m.Redact, string(dAtA[iNdEx:postIndex]))
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipEntityConfig(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthEntityConfig
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			m.XXX_unrecognized = append(m.XXX_unrecognized, dAtA[iNdEx:iNdEx+skippy]...)
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipEntityConfig(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	depth := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowEntityConfig
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
		case 1:
			iNdEx += 8
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowEntityConfig
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if length < 0 {
				return 0, ErrInvalidLengthEntityConfig
			}
			iNdEx += length
		case 3:
			depth++
		case 4:
			if depth == 0 {
				return 0, ErrUnexpectedEndOfGroupEntityConfig
			}
			depth--
		case 5:
			iNdEx += 4
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
		if iNdEx < 0 {
			return 0, ErrInvalidLengthEntityConfig
		}
		if depth == 0 {
			return iNdEx, nil
		}
	}
	return 0, io.ErrUnexpectedEOF
}

var (
	ErrInvalidLengthEntityConfig        = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowEntityConfig          = fmt.Errorf("proto: integer overflow")
	ErrUnexpectedEndOfGroupEntityConfig = fmt.Errorf("proto: unexpected end of group")
)
