// Code generated by scripts/gengraphql.go. DO NOT EDIT.

package schema

import (
	errors "errors"
	graphql1 "github.com/graphql-go/graphql"
	mapstructure "github.com/mitchellh/mapstructure"
	graphql "github.com/sensu/sensu-go/graphql"
	time "time"
)

// EntityRelatedFieldResolverArgs contains arguments provided to related when selected
type EntityRelatedFieldResolverArgs struct {
	Limit int // Limit - self descriptive
}

// EntityRelatedFieldResolverParams contains contextual info to resolve related field
type EntityRelatedFieldResolverParams struct {
	graphql.ResolveParams
	Args EntityRelatedFieldResolverArgs
}

// EntityEventsFieldResolverArgs contains arguments provided to events when selected
type EntityEventsFieldResolverArgs struct {
	OrderBy EventsListOrder // OrderBy adds optional order to the records retrieved.
	Filters []string        /*
	Filters reduces the set using given arbitrary expression[s]; expressions
	take on the form KEY: VALUE. The accepted key(s) are: status, check, entity,
	& silenced.

	Eg.

	status:passing
	status:warning
	status:incident
	check:check-disk
	entity:venice
	silenced:true
	*/
}

// EntityEventsFieldResolverParams contains contextual info to resolve events field
type EntityEventsFieldResolverParams struct {
	graphql.ResolveParams
	Args EntityEventsFieldResolverArgs
}

//
// EntityFieldResolvers represents a collection of methods whose products represent the
// response values of the 'Entity' type.
type EntityFieldResolvers interface {
	// ID implements response to request for 'id' field.
	ID(p graphql.ResolveParams) (string, error)

	// Namespace implements response to request for 'namespace' field.
	Namespace(p graphql.ResolveParams) (string, error)

	// Metadata implements response to request for 'metadata' field.
	Metadata(p graphql.ResolveParams) (interface{}, error)

	// Name implements response to request for 'name' field.
	Name(p graphql.ResolveParams) (string, error)

	// EntityClass implements response to request for 'entityClass' field.
	EntityClass(p graphql.ResolveParams) (string, error)

	// System implements response to request for 'system' field.
	System(p graphql.ResolveParams) (interface{}, error)

	// Subscriptions implements response to request for 'subscriptions' field.
	Subscriptions(p graphql.ResolveParams) ([]string, error)

	// LastSeen implements response to request for 'lastSeen' field.
	LastSeen(p graphql.ResolveParams) (*time.Time, error)

	// Deregister implements response to request for 'deregister' field.
	Deregister(p graphql.ResolveParams) (bool, error)

	// Deregistration implements response to request for 'deregistration' field.
	Deregistration(p graphql.ResolveParams) (interface{}, error)

	// User implements response to request for 'user' field.
	User(p graphql.ResolveParams) (string, error)

	// SensuAgentVersion implements response to request for 'sensuAgentVersion' field.
	SensuAgentVersion(p graphql.ResolveParams) (string, error)

	// Redact implements response to request for 'redact' field.
	Redact(p graphql.ResolveParams) ([]string, error)

	// Status implements response to request for 'status' field.
	Status(p graphql.ResolveParams) (int, error)

	// Related implements response to request for 'related' field.
	Related(p EntityRelatedFieldResolverParams) (interface{}, error)

	// Events implements response to request for 'events' field.
	Events(p EntityEventsFieldResolverParams) (interface{}, error)

	// IsSilenced implements response to request for 'isSilenced' field.
	IsSilenced(p graphql.ResolveParams) (bool, error)

	// Silences implements response to request for 'silences' field.
	Silences(p graphql.ResolveParams) (interface{}, error)

	// ToJSON implements response to request for 'toJSON' field.
	ToJSON(p graphql.ResolveParams) (interface{}, error)
}

// EntityAliases implements all methods on EntityFieldResolvers interface by using reflection to
// match name of field to a field on the given value. Intent is reduce friction
// of writing new resolvers by removing all the instances where you would simply
// have the resolvers method return a field.
type EntityAliases struct{}

// ID implements response to request for 'id' field.
func (_ EntityAliases) ID(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'id'")
	}
	return ret, err
}

// Namespace implements response to request for 'namespace' field.
func (_ EntityAliases) Namespace(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'namespace'")
	}
	return ret, err
}

// Metadata implements response to request for 'metadata' field.
func (_ EntityAliases) Metadata(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// Name implements response to request for 'name' field.
func (_ EntityAliases) Name(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'name'")
	}
	return ret, err
}

// EntityClass implements response to request for 'entityClass' field.
func (_ EntityAliases) EntityClass(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'entityClass'")
	}
	return ret, err
}

// System implements response to request for 'system' field.
func (_ EntityAliases) System(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// Subscriptions implements response to request for 'subscriptions' field.
func (_ EntityAliases) Subscriptions(p graphql.ResolveParams) ([]string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.([]string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'subscriptions'")
	}
	return ret, err
}

// LastSeen implements response to request for 'lastSeen' field.
func (_ EntityAliases) LastSeen(p graphql.ResolveParams) (*time.Time, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(*time.Time)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'lastSeen'")
	}
	return ret, err
}

// Deregister implements response to request for 'deregister' field.
func (_ EntityAliases) Deregister(p graphql.ResolveParams) (bool, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(bool)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'deregister'")
	}
	return ret, err
}

// Deregistration implements response to request for 'deregistration' field.
func (_ EntityAliases) Deregistration(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// User implements response to request for 'user' field.
func (_ EntityAliases) User(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'user'")
	}
	return ret, err
}

// SensuAgentVersion implements response to request for 'sensuAgentVersion' field.
func (_ EntityAliases) SensuAgentVersion(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'sensuAgentVersion'")
	}
	return ret, err
}

// Redact implements response to request for 'redact' field.
func (_ EntityAliases) Redact(p graphql.ResolveParams) ([]string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.([]string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'redact'")
	}
	return ret, err
}

// Status implements response to request for 'status' field.
func (_ EntityAliases) Status(p graphql.ResolveParams) (int, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := graphql1.Int.ParseValue(val).(int)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'status'")
	}
	return ret, err
}

// Related implements response to request for 'related' field.
func (_ EntityAliases) Related(p EntityRelatedFieldResolverParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// Events implements response to request for 'events' field.
func (_ EntityAliases) Events(p EntityEventsFieldResolverParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// IsSilenced implements response to request for 'isSilenced' field.
func (_ EntityAliases) IsSilenced(p graphql.ResolveParams) (bool, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(bool)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'isSilenced'")
	}
	return ret, err
}

// Silences implements response to request for 'silences' field.
func (_ EntityAliases) Silences(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// ToJSON implements response to request for 'toJSON' field.
func (_ EntityAliases) ToJSON(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

/*
EntityType Entity is the Entity supplying the event. The default Entity for any
Event is the running Agent process--if the Event is sent by an Agent.
*/
var EntityType = graphql.NewType("Entity", graphql.ObjectKind)

// RegisterEntity registers Entity object type with given service.
func RegisterEntity(svc *graphql.Service, impl EntityFieldResolvers) {
	svc.RegisterObject(_ObjectTypeEntityDesc, impl)
}
func _ObjTypeEntityIDHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		ID(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.ID(frp)
	}
}

func _ObjTypeEntityNamespaceHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Namespace(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Namespace(frp)
	}
}

func _ObjTypeEntityMetadataHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Metadata(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Metadata(frp)
	}
}

func _ObjTypeEntityNameHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Name(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Name(frp)
	}
}

func _ObjTypeEntityEntityClassHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		EntityClass(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.EntityClass(frp)
	}
}

func _ObjTypeEntitySystemHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		System(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.System(frp)
	}
}

func _ObjTypeEntitySubscriptionsHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Subscriptions(p graphql.ResolveParams) ([]string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Subscriptions(frp)
	}
}

func _ObjTypeEntityLastSeenHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		LastSeen(p graphql.ResolveParams) (*time.Time, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.LastSeen(frp)
	}
}

func _ObjTypeEntityDeregisterHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Deregister(p graphql.ResolveParams) (bool, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Deregister(frp)
	}
}

func _ObjTypeEntityDeregistrationHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Deregistration(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Deregistration(frp)
	}
}

func _ObjTypeEntityUserHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		User(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.User(frp)
	}
}

func _ObjTypeEntitySensuAgentVersionHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		SensuAgentVersion(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.SensuAgentVersion(frp)
	}
}

func _ObjTypeEntityRedactHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Redact(p graphql.ResolveParams) ([]string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Redact(frp)
	}
}

func _ObjTypeEntityStatusHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Status(p graphql.ResolveParams) (int, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Status(frp)
	}
}

func _ObjTypeEntityRelatedHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Related(p EntityRelatedFieldResolverParams) (interface{}, error)
	})
	return func(p graphql1.ResolveParams) (interface{}, error) {
		frp := EntityRelatedFieldResolverParams{ResolveParams: p}
		err := mapstructure.Decode(p.Args, &frp.Args)
		if err != nil {
			return nil, err
		}

		return resolver.Related(frp)
	}
}

func _ObjTypeEntityEventsHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Events(p EntityEventsFieldResolverParams) (interface{}, error)
	})
	return func(p graphql1.ResolveParams) (interface{}, error) {
		frp := EntityEventsFieldResolverParams{ResolveParams: p}
		err := mapstructure.Decode(p.Args, &frp.Args)
		if err != nil {
			return nil, err
		}

		return resolver.Events(frp)
	}
}

func _ObjTypeEntityIsSilencedHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		IsSilenced(p graphql.ResolveParams) (bool, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.IsSilenced(frp)
	}
}

func _ObjTypeEntitySilencesHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Silences(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Silences(frp)
	}
}

func _ObjTypeEntityToJSONHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		ToJSON(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.ToJSON(frp)
	}
}

func _ObjectTypeEntityConfigFn() graphql1.ObjectConfig {
	return graphql1.ObjectConfig{
		Description: "Entity is the Entity supplying the event. The default Entity for any\nEvent is the running Agent process--if the Event is sent by an Agent.",
		Fields: graphql1.Fields{
			"deregister": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "deregister",
				Type:              graphql1.NewNonNull(graphql1.Boolean),
			},
			"deregistration": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "deregistration",
				Type:              graphql1.NewNonNull(graphql.OutputType("Deregistration")),
			},
			"entityClass": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "entityClass",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"events": &graphql1.Field{
				Args: graphql1.FieldConfigArgument{
					"filters": &graphql1.ArgumentConfig{
						DefaultValue: []interface{}{},
						Description:  "Filters reduces the set using given arbitrary expression[s]; expressions\ntake on the form KEY: VALUE. The accepted key(s) are: status, check, entity,\n& silenced.\n\nEg.\n\nstatus:passing\nstatus:warning\nstatus:incident\ncheck:check-disk\nentity:venice\nsilenced:true",
						Type:         graphql1.NewList(graphql1.NewNonNull(graphql1.String)),
					},
					"orderBy": &graphql1.ArgumentConfig{
						DefaultValue: "SEVERITY",
						Description:  "OrderBy adds optional order to the records retrieved.",
						Type:         graphql.InputType("EventsListOrder"),
					},
				},
				DeprecationReason: "",
				Description:       "All events associated with the entity.",
				Name:              "events",
				Type:              graphql1.NewNonNull(graphql1.NewList(graphql1.NewNonNull(graphql.OutputType("Event")))),
			},
			"id": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "The globally unique identifier of the record",
				Name:              "id",
				Type:              graphql1.NewNonNull(graphql1.ID),
			},
			"isSilenced": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "isSilenced return true if the entity has any silences associated with it.",
				Name:              "isSilenced",
				Type:              graphql1.NewNonNull(graphql1.Boolean),
			},
			"lastSeen": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "lastSeen",
				Type:              graphql1.DateTime,
			},
			"metadata": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "metadata contains name, namespace, labels and annotations of the record",
				Name:              "metadata",
				Type:              graphql.OutputType("ObjectMeta"),
			},
			"name": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "use metadata",
				Description:       "unique identifier for the entity",
				Name:              "name",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"namespace": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "use metadata",
				Description:       "Namespace in which this record resides",
				Name:              "namespace",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"redact": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Redact contains the fields to redact on the agent.",
				Name:              "redact",
				Type:              graphql1.NewNonNull(graphql1.NewList(graphql1.NewNonNull(graphql1.String))),
			},
			"related": &graphql1.Field{
				Args: graphql1.FieldConfigArgument{"limit": &graphql1.ArgumentConfig{
					DefaultValue: 10,
					Description:  "self descriptive",
					Type:         graphql1.Int,
				}},
				DeprecationReason: "",
				Description:       "Related returns a sorted list of like entities from the same environment.",
				Name:              "related",
				Type:              graphql1.NewNonNull(graphql1.NewList(graphql.OutputType("Entity"))),
			},
			"sensuAgentVersion": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "If agent; reflects the version reported by the sensu-agent client.",
				Name:              "sensuAgentVersion",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"silences": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "All silences matching the entity's subscriptions and where the silence\nmatches all checks.",
				Name:              "silences",
				Type:              graphql1.NewNonNull(graphql1.NewList(graphql1.NewNonNull(graphql.OutputType("Silenced")))),
			},
			"status": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Status represents the MAX status of all events associated with the entity. If\nno events are present value is -1.",
				Name:              "status",
				Type:              graphql1.NewNonNull(graphql1.Int),
			},
			"subscriptions": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "subscriptions",
				Type:              graphql1.NewList(graphql1.NewNonNull(graphql1.String)),
			},
			"system": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "system",
				Type:              graphql1.NewNonNull(graphql.OutputType("System")),
			},
			"toJSON": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "toJSON returns a REST API compatible representation of the resource. Handy for\nsharing snippets that can then be imported with `sensuctl create`.",
				Name:              "toJSON",
				Type:              graphql1.NewNonNull(graphql.OutputType("JSON")),
			},
			"user": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "user",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
		},
		Interfaces: []*graphql1.Interface{
			graphql.Interface("Node"),
			graphql.Interface("Namespaced"),
			graphql.Interface("Silenceable"),
			graphql.Interface("Resource")},
		IsTypeOf: func(_ graphql1.IsTypeOfParams) bool {
			// NOTE:
			// Panic by default. Intent is that when Service is invoked, values of
			// these fields are updated with instantiated resolvers. If these
			// defaults are called it is most certainly programmer err.
			// If you're see this comment then: 'Whoops! Sorry, my bad.'
			panic("Unimplemented; see EntityFieldResolvers.")
		},
		Name: "Entity",
	}
}

// describe Entity's configuration; kept private to avoid unintentional tampering of configuration at runtime.
var _ObjectTypeEntityDesc = graphql.ObjectDesc{
	Config: _ObjectTypeEntityConfigFn,
	FieldHandlers: map[string]graphql.FieldHandler{
		"deregister":        _ObjTypeEntityDeregisterHandler,
		"deregistration":    _ObjTypeEntityDeregistrationHandler,
		"entityClass":       _ObjTypeEntityEntityClassHandler,
		"events":            _ObjTypeEntityEventsHandler,
		"id":                _ObjTypeEntityIDHandler,
		"isSilenced":        _ObjTypeEntityIsSilencedHandler,
		"lastSeen":          _ObjTypeEntityLastSeenHandler,
		"metadata":          _ObjTypeEntityMetadataHandler,
		"name":              _ObjTypeEntityNameHandler,
		"namespace":         _ObjTypeEntityNamespaceHandler,
		"redact":            _ObjTypeEntityRedactHandler,
		"related":           _ObjTypeEntityRelatedHandler,
		"sensuAgentVersion": _ObjTypeEntitySensuAgentVersionHandler,
		"silences":          _ObjTypeEntitySilencesHandler,
		"status":            _ObjTypeEntityStatusHandler,
		"subscriptions":     _ObjTypeEntitySubscriptionsHandler,
		"system":            _ObjTypeEntitySystemHandler,
		"toJSON":            _ObjTypeEntityToJSONHandler,
		"user":              _ObjTypeEntityUserHandler,
	},
}

//
// SystemFieldResolvers represents a collection of methods whose products represent the
// response values of the 'System' type.
type SystemFieldResolvers interface {
	// Hostname implements response to request for 'hostname' field.
	Hostname(p graphql.ResolveParams) (string, error)

	// Network implements response to request for 'network' field.
	Network(p graphql.ResolveParams) (interface{}, error)

	// Os implements response to request for 'os' field.
	Os(p graphql.ResolveParams) (string, error)

	// Platform implements response to request for 'platform' field.
	Platform(p graphql.ResolveParams) (string, error)

	// PlatformFamily implements response to request for 'platformFamily' field.
	PlatformFamily(p graphql.ResolveParams) (string, error)

	// PlatformVersion implements response to request for 'platformVersion' field.
	PlatformVersion(p graphql.ResolveParams) (string, error)

	// Arch implements response to request for 'arch' field.
	Arch(p graphql.ResolveParams) (string, error)

	// ARMVersion implements response to request for 'ARMVersion' field.
	ARMVersion(p graphql.ResolveParams) (int, error)

	// LibCType implements response to request for 'libCType' field.
	LibCType(p graphql.ResolveParams) (string, error)

	// VMSystem implements response to request for 'VMSystem' field.
	VMSystem(p graphql.ResolveParams) (string, error)

	// VMRole implements response to request for 'VMRole' field.
	VMRole(p graphql.ResolveParams) (string, error)

	// CloudProvider implements response to request for 'cloudProvider' field.
	CloudProvider(p graphql.ResolveParams) (string, error)

	// FloatType implements response to request for 'floatType' field.
	FloatType(p graphql.ResolveParams) (string, error)

	// Processes implements response to request for 'processes' field.
	Processes(p graphql.ResolveParams) (interface{}, error)
}

// SystemAliases implements all methods on SystemFieldResolvers interface by using reflection to
// match name of field to a field on the given value. Intent is reduce friction
// of writing new resolvers by removing all the instances where you would simply
// have the resolvers method return a field.
type SystemAliases struct{}

// Hostname implements response to request for 'hostname' field.
func (_ SystemAliases) Hostname(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'hostname'")
	}
	return ret, err
}

// Network implements response to request for 'network' field.
func (_ SystemAliases) Network(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// Os implements response to request for 'os' field.
func (_ SystemAliases) Os(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'os'")
	}
	return ret, err
}

// Platform implements response to request for 'platform' field.
func (_ SystemAliases) Platform(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'platform'")
	}
	return ret, err
}

// PlatformFamily implements response to request for 'platformFamily' field.
func (_ SystemAliases) PlatformFamily(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'platformFamily'")
	}
	return ret, err
}

// PlatformVersion implements response to request for 'platformVersion' field.
func (_ SystemAliases) PlatformVersion(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'platformVersion'")
	}
	return ret, err
}

// Arch implements response to request for 'arch' field.
func (_ SystemAliases) Arch(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'arch'")
	}
	return ret, err
}

// ARMVersion implements response to request for 'ARMVersion' field.
func (_ SystemAliases) ARMVersion(p graphql.ResolveParams) (int, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := graphql1.Int.ParseValue(val).(int)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'ARMVersion'")
	}
	return ret, err
}

// LibCType implements response to request for 'libCType' field.
func (_ SystemAliases) LibCType(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'libCType'")
	}
	return ret, err
}

// VMSystem implements response to request for 'VMSystem' field.
func (_ SystemAliases) VMSystem(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'VMSystem'")
	}
	return ret, err
}

// VMRole implements response to request for 'VMRole' field.
func (_ SystemAliases) VMRole(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'VMRole'")
	}
	return ret, err
}

// CloudProvider implements response to request for 'cloudProvider' field.
func (_ SystemAliases) CloudProvider(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'cloudProvider'")
	}
	return ret, err
}

// FloatType implements response to request for 'floatType' field.
func (_ SystemAliases) FloatType(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'floatType'")
	}
	return ret, err
}

// Processes implements response to request for 'processes' field.
func (_ SystemAliases) Processes(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

/*
SystemType System contains information about the system that the Agent process
is running on, used for additional Entity context.
*/
var SystemType = graphql.NewType("System", graphql.ObjectKind)

// RegisterSystem registers System object type with given service.
func RegisterSystem(svc *graphql.Service, impl SystemFieldResolvers) {
	svc.RegisterObject(_ObjectTypeSystemDesc, impl)
}
func _ObjTypeSystemHostnameHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Hostname(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Hostname(frp)
	}
}

func _ObjTypeSystemNetworkHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Network(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Network(frp)
	}
}

func _ObjTypeSystemOsHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Os(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Os(frp)
	}
}

func _ObjTypeSystemPlatformHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Platform(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Platform(frp)
	}
}

func _ObjTypeSystemPlatformFamilyHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		PlatformFamily(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.PlatformFamily(frp)
	}
}

func _ObjTypeSystemPlatformVersionHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		PlatformVersion(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.PlatformVersion(frp)
	}
}

func _ObjTypeSystemArchHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Arch(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Arch(frp)
	}
}

func _ObjTypeSystemARMVersionHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		ARMVersion(p graphql.ResolveParams) (int, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.ARMVersion(frp)
	}
}

func _ObjTypeSystemLibCTypeHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		LibCType(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.LibCType(frp)
	}
}

func _ObjTypeSystemVMSystemHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		VMSystem(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.VMSystem(frp)
	}
}

func _ObjTypeSystemVMRoleHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		VMRole(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.VMRole(frp)
	}
}

func _ObjTypeSystemCloudProviderHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		CloudProvider(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.CloudProvider(frp)
	}
}

func _ObjTypeSystemFloatTypeHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		FloatType(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.FloatType(frp)
	}
}

func _ObjTypeSystemProcessesHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Processes(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Processes(frp)
	}
}

func _ObjectTypeSystemConfigFn() graphql1.ObjectConfig {
	return graphql1.ObjectConfig{
		Description: "System contains information about the system that the Agent process\nis running on, used for additional Entity context.",
		Fields: graphql1.Fields{
			"ARMVersion": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Version of ARM architecture in play",
				Name:              "ARMVersion",
				Type:              graphql1.NewNonNull(graphql1.Int),
			},
			"VMRole": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "VMRole indicates the VM role of the agent (host/guest)",
				Name:              "VMRole",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"VMSystem": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "VMSystem indicates the VM system of the agent (kvm, vbox, etc)",
				Name:              "VMSystem",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"arch": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Architecture; eg. 386, amd64, arm, ...",
				Name:              "arch",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"cloudProvider": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "CloudProvider indicates the public cloud the agent is running on.",
				Name:              "cloudProvider",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"floatType": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Float type",
				Name:              "floatType",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"hostname": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "hostname",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"libCType": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "LibCType indicates the type of libc the agent has access to (glibc, musl, etc)",
				Name:              "libCType",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"network": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "network",
				Type:              graphql1.NewNonNull(graphql.OutputType("Network")),
			},
			"os": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Operating system; eg. freebsd, linux, ...",
				Name:              "os",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"platform": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Operating system platform; eg. ubuntu, linuxmint, ...",
				Name:              "platform",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"platformFamily": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Operating system family; eg. debian, rhel, ...",
				Name:              "platformFamily",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"platformVersion": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Version of complete operating system; eg. 10.12.2, ...",
				Name:              "platformVersion",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"processes": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Processes contains information about the local processes on the agent.",
				Name:              "processes",
				Type:              graphql1.NewNonNull(graphql1.NewList(graphql1.NewNonNull(graphql.OutputType("Process")))),
			},
		},
		Interfaces: []*graphql1.Interface{},
		IsTypeOf: func(_ graphql1.IsTypeOfParams) bool {
			// NOTE:
			// Panic by default. Intent is that when Service is invoked, values of
			// these fields are updated with instantiated resolvers. If these
			// defaults are called it is most certainly programmer err.
			// If you're see this comment then: 'Whoops! Sorry, my bad.'
			panic("Unimplemented; see SystemFieldResolvers.")
		},
		Name: "System",
	}
}

// describe System's configuration; kept private to avoid unintentional tampering of configuration at runtime.
var _ObjectTypeSystemDesc = graphql.ObjectDesc{
	Config: _ObjectTypeSystemConfigFn,
	FieldHandlers: map[string]graphql.FieldHandler{
		"ARMVersion":      _ObjTypeSystemARMVersionHandler,
		"VMRole":          _ObjTypeSystemVMRoleHandler,
		"VMSystem":        _ObjTypeSystemVMSystemHandler,
		"arch":            _ObjTypeSystemArchHandler,
		"cloudProvider":   _ObjTypeSystemCloudProviderHandler,
		"floatType":       _ObjTypeSystemFloatTypeHandler,
		"hostname":        _ObjTypeSystemHostnameHandler,
		"libCType":        _ObjTypeSystemLibCTypeHandler,
		"network":         _ObjTypeSystemNetworkHandler,
		"os":              _ObjTypeSystemOsHandler,
		"platform":        _ObjTypeSystemPlatformHandler,
		"platformFamily":  _ObjTypeSystemPlatformFamilyHandler,
		"platformVersion": _ObjTypeSystemPlatformVersionHandler,
		"processes":       _ObjTypeSystemProcessesHandler,
	},
}

//
// ProcessFieldResolvers represents a collection of methods whose products represent the
// response values of the 'Process' type.
type ProcessFieldResolvers interface {
	// Name implements response to request for 'name' field.
	Name(p graphql.ResolveParams) (string, error)

	// Pid implements response to request for 'pid' field.
	Pid(p graphql.ResolveParams) (int, error)

	// Ppid implements response to request for 'ppid' field.
	Ppid(p graphql.ResolveParams) (int, error)

	// Status implements response to request for 'status' field.
	Status(p graphql.ResolveParams) (string, error)

	// Created implements response to request for 'created' field.
	Created(p graphql.ResolveParams) (time.Time, error)

	// Running implements response to request for 'running' field.
	Running(p graphql.ResolveParams) (bool, error)

	// Background implements response to request for 'background' field.
	Background(p graphql.ResolveParams) (bool, error)

	// CpuPercent implements response to request for 'cpuPercent' field.
	CpuPercent(p graphql.ResolveParams) (float64, error)

	// MemoryPercent implements response to request for 'memoryPercent' field.
	MemoryPercent(p graphql.ResolveParams) (float64, error)
}

// ProcessAliases implements all methods on ProcessFieldResolvers interface by using reflection to
// match name of field to a field on the given value. Intent is reduce friction
// of writing new resolvers by removing all the instances where you would simply
// have the resolvers method return a field.
type ProcessAliases struct{}

// Name implements response to request for 'name' field.
func (_ ProcessAliases) Name(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'name'")
	}
	return ret, err
}

// Pid implements response to request for 'pid' field.
func (_ ProcessAliases) Pid(p graphql.ResolveParams) (int, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := graphql1.Int.ParseValue(val).(int)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'pid'")
	}
	return ret, err
}

// Ppid implements response to request for 'ppid' field.
func (_ ProcessAliases) Ppid(p graphql.ResolveParams) (int, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := graphql1.Int.ParseValue(val).(int)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'ppid'")
	}
	return ret, err
}

// Status implements response to request for 'status' field.
func (_ ProcessAliases) Status(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'status'")
	}
	return ret, err
}

// Created implements response to request for 'created' field.
func (_ ProcessAliases) Created(p graphql.ResolveParams) (time.Time, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(time.Time)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'created'")
	}
	return ret, err
}

// Running implements response to request for 'running' field.
func (_ ProcessAliases) Running(p graphql.ResolveParams) (bool, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(bool)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'running'")
	}
	return ret, err
}

// Background implements response to request for 'background' field.
func (_ ProcessAliases) Background(p graphql.ResolveParams) (bool, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(bool)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'background'")
	}
	return ret, err
}

// CpuPercent implements response to request for 'cpuPercent' field.
func (_ ProcessAliases) CpuPercent(p graphql.ResolveParams) (float64, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := graphql1.Float.ParseValue(val).(float64)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'cpuPercent'")
	}
	return ret, err
}

// MemoryPercent implements response to request for 'memoryPercent' field.
func (_ ProcessAliases) MemoryPercent(p graphql.ResolveParams) (float64, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := graphql1.Float.ParseValue(val).(float64)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'memoryPercent'")
	}
	return ret, err
}

// ProcessType Process contains information about a local process.
var ProcessType = graphql.NewType("Process", graphql.ObjectKind)

// RegisterProcess registers Process object type with given service.
func RegisterProcess(svc *graphql.Service, impl ProcessFieldResolvers) {
	svc.RegisterObject(_ObjectTypeProcessDesc, impl)
}
func _ObjTypeProcessNameHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Name(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Name(frp)
	}
}

func _ObjTypeProcessPidHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Pid(p graphql.ResolveParams) (int, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Pid(frp)
	}
}

func _ObjTypeProcessPpidHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Ppid(p graphql.ResolveParams) (int, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Ppid(frp)
	}
}

func _ObjTypeProcessStatusHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Status(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Status(frp)
	}
}

func _ObjTypeProcessCreatedHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Created(p graphql.ResolveParams) (time.Time, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Created(frp)
	}
}

func _ObjTypeProcessRunningHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Running(p graphql.ResolveParams) (bool, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Running(frp)
	}
}

func _ObjTypeProcessBackgroundHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Background(p graphql.ResolveParams) (bool, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Background(frp)
	}
}

func _ObjTypeProcessCpuPercentHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		CpuPercent(p graphql.ResolveParams) (float64, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.CpuPercent(frp)
	}
}

func _ObjTypeProcessMemoryPercentHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		MemoryPercent(p graphql.ResolveParams) (float64, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.MemoryPercent(frp)
	}
}

func _ObjectTypeProcessConfigFn() graphql1.ObjectConfig {
	return graphql1.ObjectConfig{
		Description: "Process contains information about a local process.",
		Fields: graphql1.Fields{
			"background": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "background",
				Type:              graphql1.NewNonNull(graphql1.Boolean),
			},
			"cpuPercent": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "cpuPercent",
				Type:              graphql1.NewNonNull(graphql1.Float),
			},
			"created": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "created",
				Type:              graphql1.NewNonNull(graphql1.DateTime),
			},
			"memoryPercent": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "memoryPercent",
				Type:              graphql1.NewNonNull(graphql1.Float),
			},
			"name": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "name",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"pid": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "pid",
				Type:              graphql1.NewNonNull(graphql1.Int),
			},
			"ppid": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "ppid",
				Type:              graphql1.NewNonNull(graphql1.Int),
			},
			"running": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "running",
				Type:              graphql1.NewNonNull(graphql1.Boolean),
			},
			"status": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "status",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
		},
		Interfaces: []*graphql1.Interface{},
		IsTypeOf: func(_ graphql1.IsTypeOfParams) bool {
			// NOTE:
			// Panic by default. Intent is that when Service is invoked, values of
			// these fields are updated with instantiated resolvers. If these
			// defaults are called it is most certainly programmer err.
			// If you're see this comment then: 'Whoops! Sorry, my bad.'
			panic("Unimplemented; see ProcessFieldResolvers.")
		},
		Name: "Process",
	}
}

// describe Process's configuration; kept private to avoid unintentional tampering of configuration at runtime.
var _ObjectTypeProcessDesc = graphql.ObjectDesc{
	Config: _ObjectTypeProcessConfigFn,
	FieldHandlers: map[string]graphql.FieldHandler{
		"background":    _ObjTypeProcessBackgroundHandler,
		"cpuPercent":    _ObjTypeProcessCpuPercentHandler,
		"created":       _ObjTypeProcessCreatedHandler,
		"memoryPercent": _ObjTypeProcessMemoryPercentHandler,
		"name":          _ObjTypeProcessNameHandler,
		"pid":           _ObjTypeProcessPidHandler,
		"ppid":          _ObjTypeProcessPpidHandler,
		"running":       _ObjTypeProcessRunningHandler,
		"status":        _ObjTypeProcessStatusHandler,
	},
}

//
// BackendEntityFieldResolvers represents a collection of methods whose products represent the
// response values of the 'BackendEntity' type.
type BackendEntityFieldResolvers interface {
	// Meta implements response to request for 'meta' field.
	Meta(p graphql.ResolveParams) (interface{}, error)
}

// BackendEntityAliases implements all methods on BackendEntityFieldResolvers interface by using reflection to
// match name of field to a field on the given value. Intent is reduce friction
// of writing new resolvers by removing all the instances where you would simply
// have the resolvers method return a field.
type BackendEntityAliases struct{}

// Meta implements response to request for 'meta' field.
func (_ BackendEntityAliases) Meta(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// BackendEntityType BackendEntity contains information about a particular backend.
var BackendEntityType = graphql.NewType("BackendEntity", graphql.ObjectKind)

// RegisterBackendEntity registers BackendEntity object type with given service.
func RegisterBackendEntity(svc *graphql.Service, impl BackendEntityFieldResolvers) {
	svc.RegisterObject(_ObjectTypeBackendEntityDesc, impl)
}
func _ObjTypeBackendEntityMetaHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Meta(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Meta(frp)
	}
}

func _ObjectTypeBackendEntityConfigFn() graphql1.ObjectConfig {
	return graphql1.ObjectConfig{
		Description: "BackendEntity contains information about a particular backend.",
		Fields: graphql1.Fields{"meta": &graphql1.Field{
			Args:              graphql1.FieldConfigArgument{},
			DeprecationReason: "",
			Description:       "self descriptive",
			Name:              "meta",
			Type:              graphql.OutputType("ObjectMeta"),
		}},
		Interfaces: []*graphql1.Interface{},
		IsTypeOf: func(_ graphql1.IsTypeOfParams) bool {
			// NOTE:
			// Panic by default. Intent is that when Service is invoked, values of
			// these fields are updated with instantiated resolvers. If these
			// defaults are called it is most certainly programmer err.
			// If you're see this comment then: 'Whoops! Sorry, my bad.'
			panic("Unimplemented; see BackendEntityFieldResolvers.")
		},
		Name: "BackendEntity",
	}
}

// describe BackendEntity's configuration; kept private to avoid unintentional tampering of configuration at runtime.
var _ObjectTypeBackendEntityDesc = graphql.ObjectDesc{
	Config:        _ObjectTypeBackendEntityConfigFn,
	FieldHandlers: map[string]graphql.FieldHandler{"meta": _ObjTypeBackendEntityMetaHandler},
}

//
// NetworkFieldResolvers represents a collection of methods whose products represent the
// response values of the 'Network' type.
type NetworkFieldResolvers interface {
	// Interfaces implements response to request for 'interfaces' field.
	Interfaces(p graphql.ResolveParams) (interface{}, error)
}

// NetworkAliases implements all methods on NetworkFieldResolvers interface by using reflection to
// match name of field to a field on the given value. Intent is reduce friction
// of writing new resolvers by removing all the instances where you would simply
// have the resolvers method return a field.
type NetworkAliases struct{}

// Interfaces implements response to request for 'interfaces' field.
func (_ NetworkAliases) Interfaces(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

/*
NetworkType Network contains information about the system network interfaces
that the Agent process is running on, used for additional Entity
context.
*/
var NetworkType = graphql.NewType("Network", graphql.ObjectKind)

// RegisterNetwork registers Network object type with given service.
func RegisterNetwork(svc *graphql.Service, impl NetworkFieldResolvers) {
	svc.RegisterObject(_ObjectTypeNetworkDesc, impl)
}
func _ObjTypeNetworkInterfacesHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Interfaces(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Interfaces(frp)
	}
}

func _ObjectTypeNetworkConfigFn() graphql1.ObjectConfig {
	return graphql1.ObjectConfig{
		Description: "Network contains information about the system network interfaces\nthat the Agent process is running on, used for additional Entity\ncontext.",
		Fields: graphql1.Fields{"interfaces": &graphql1.Field{
			Args:              graphql1.FieldConfigArgument{},
			DeprecationReason: "",
			Description:       "self descriptive",
			Name:              "interfaces",
			Type:              graphql1.NewNonNull(graphql1.NewList(graphql1.NewNonNull(graphql.OutputType("NetworkInterface")))),
		}},
		Interfaces: []*graphql1.Interface{},
		IsTypeOf: func(_ graphql1.IsTypeOfParams) bool {
			// NOTE:
			// Panic by default. Intent is that when Service is invoked, values of
			// these fields are updated with instantiated resolvers. If these
			// defaults are called it is most certainly programmer err.
			// If you're see this comment then: 'Whoops! Sorry, my bad.'
			panic("Unimplemented; see NetworkFieldResolvers.")
		},
		Name: "Network",
	}
}

// describe Network's configuration; kept private to avoid unintentional tampering of configuration at runtime.
var _ObjectTypeNetworkDesc = graphql.ObjectDesc{
	Config:        _ObjectTypeNetworkConfigFn,
	FieldHandlers: map[string]graphql.FieldHandler{"interfaces": _ObjTypeNetworkInterfacesHandler},
}

//
// NetworkInterfaceFieldResolvers represents a collection of methods whose products represent the
// response values of the 'NetworkInterface' type.
type NetworkInterfaceFieldResolvers interface {
	// Name implements response to request for 'name' field.
	Name(p graphql.ResolveParams) (string, error)

	// Mac implements response to request for 'mac' field.
	Mac(p graphql.ResolveParams) (string, error)

	// Addresses implements response to request for 'addresses' field.
	Addresses(p graphql.ResolveParams) ([]string, error)
}

// NetworkInterfaceAliases implements all methods on NetworkInterfaceFieldResolvers interface by using reflection to
// match name of field to a field on the given value. Intent is reduce friction
// of writing new resolvers by removing all the instances where you would simply
// have the resolvers method return a field.
type NetworkInterfaceAliases struct{}

// Name implements response to request for 'name' field.
func (_ NetworkInterfaceAliases) Name(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'name'")
	}
	return ret, err
}

// Mac implements response to request for 'mac' field.
func (_ NetworkInterfaceAliases) Mac(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'mac'")
	}
	return ret, err
}

// Addresses implements response to request for 'addresses' field.
func (_ NetworkInterfaceAliases) Addresses(p graphql.ResolveParams) ([]string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.([]string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'addresses'")
	}
	return ret, err
}

/*
NetworkInterfaceType NetworkInterface contains information about a system network
interface.
*/
var NetworkInterfaceType = graphql.NewType("NetworkInterface", graphql.ObjectKind)

// RegisterNetworkInterface registers NetworkInterface object type with given service.
func RegisterNetworkInterface(svc *graphql.Service, impl NetworkInterfaceFieldResolvers) {
	svc.RegisterObject(_ObjectTypeNetworkInterfaceDesc, impl)
}
func _ObjTypeNetworkInterfaceNameHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Name(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Name(frp)
	}
}

func _ObjTypeNetworkInterfaceMacHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Mac(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Mac(frp)
	}
}

func _ObjTypeNetworkInterfaceAddressesHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Addresses(p graphql.ResolveParams) ([]string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Addresses(frp)
	}
}

func _ObjectTypeNetworkInterfaceConfigFn() graphql1.ObjectConfig {
	return graphql1.ObjectConfig{
		Description: "NetworkInterface contains information about a system network\ninterface.",
		Fields: graphql1.Fields{
			"addresses": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "IP address(es) associated with the network interface",
				Name:              "addresses",
				Type:              graphql1.NewNonNull(graphql1.NewList(graphql1.NewNonNull(graphql1.String))),
			},
			"mac": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "MAC address associated with the network interface",
				Name:              "mac",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
			"name": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "Name given to the network interface; en0, wi0, tunnel0, etc.",
				Name:              "name",
				Type:              graphql1.NewNonNull(graphql1.String),
			},
		},
		Interfaces: []*graphql1.Interface{},
		IsTypeOf: func(_ graphql1.IsTypeOfParams) bool {
			// NOTE:
			// Panic by default. Intent is that when Service is invoked, values of
			// these fields are updated with instantiated resolvers. If these
			// defaults are called it is most certainly programmer err.
			// If you're see this comment then: 'Whoops! Sorry, my bad.'
			panic("Unimplemented; see NetworkInterfaceFieldResolvers.")
		},
		Name: "NetworkInterface",
	}
}

// describe NetworkInterface's configuration; kept private to avoid unintentional tampering of configuration at runtime.
var _ObjectTypeNetworkInterfaceDesc = graphql.ObjectDesc{
	Config: _ObjectTypeNetworkInterfaceConfigFn,
	FieldHandlers: map[string]graphql.FieldHandler{
		"addresses": _ObjTypeNetworkInterfaceAddressesHandler,
		"mac":       _ObjTypeNetworkInterfaceMacHandler,
		"name":      _ObjTypeNetworkInterfaceNameHandler,
	},
}

//
// DeregistrationFieldResolvers represents a collection of methods whose products represent the
// response values of the 'Deregistration' type.
type DeregistrationFieldResolvers interface {
	// Handler implements response to request for 'handler' field.
	Handler(p graphql.ResolveParams) (string, error)
}

// DeregistrationAliases implements all methods on DeregistrationFieldResolvers interface by using reflection to
// match name of field to a field on the given value. Intent is reduce friction
// of writing new resolvers by removing all the instances where you would simply
// have the resolvers method return a field.
type DeregistrationAliases struct{}

// Handler implements response to request for 'handler' field.
func (_ DeregistrationAliases) Handler(p graphql.ResolveParams) (string, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	ret, ok := val.(string)
	if err != nil {
		return ret, err
	}
	if !ok {
		return ret, errors.New("unable to coerce value for field 'handler'")
	}
	return ret, err
}

// DeregistrationType Deregistration contains configuration for Sensu entity de-registration.
var DeregistrationType = graphql.NewType("Deregistration", graphql.ObjectKind)

// RegisterDeregistration registers Deregistration object type with given service.
func RegisterDeregistration(svc *graphql.Service, impl DeregistrationFieldResolvers) {
	svc.RegisterObject(_ObjectTypeDeregistrationDesc, impl)
}
func _ObjTypeDeregistrationHandlerHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Handler(p graphql.ResolveParams) (string, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Handler(frp)
	}
}

func _ObjectTypeDeregistrationConfigFn() graphql1.ObjectConfig {
	return graphql1.ObjectConfig{
		Description: "Deregistration contains configuration for Sensu entity de-registration.",
		Fields: graphql1.Fields{"handler": &graphql1.Field{
			Args:              graphql1.FieldConfigArgument{},
			DeprecationReason: "",
			Description:       "self descriptive",
			Name:              "handler",
			Type:              graphql1.NewNonNull(graphql1.String),
		}},
		Interfaces: []*graphql1.Interface{},
		IsTypeOf: func(_ graphql1.IsTypeOfParams) bool {
			// NOTE:
			// Panic by default. Intent is that when Service is invoked, values of
			// these fields are updated with instantiated resolvers. If these
			// defaults are called it is most certainly programmer err.
			// If you're see this comment then: 'Whoops! Sorry, my bad.'
			panic("Unimplemented; see DeregistrationFieldResolvers.")
		},
		Name: "Deregistration",
	}
}

// describe Deregistration's configuration; kept private to avoid unintentional tampering of configuration at runtime.
var _ObjectTypeDeregistrationDesc = graphql.ObjectDesc{
	Config:        _ObjectTypeDeregistrationConfigFn,
	FieldHandlers: map[string]graphql.FieldHandler{"handler": _ObjTypeDeregistrationHandlerHandler},
}

//
// EntityConnectionFieldResolvers represents a collection of methods whose products represent the
// response values of the 'EntityConnection' type.
type EntityConnectionFieldResolvers interface {
	// Nodes implements response to request for 'nodes' field.
	Nodes(p graphql.ResolveParams) (interface{}, error)

	// PageInfo implements response to request for 'pageInfo' field.
	PageInfo(p graphql.ResolveParams) (interface{}, error)
}

// EntityConnectionAliases implements all methods on EntityConnectionFieldResolvers interface by using reflection to
// match name of field to a field on the given value. Intent is reduce friction
// of writing new resolvers by removing all the instances where you would simply
// have the resolvers method return a field.
type EntityConnectionAliases struct{}

// Nodes implements response to request for 'nodes' field.
func (_ EntityConnectionAliases) Nodes(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// PageInfo implements response to request for 'pageInfo' field.
func (_ EntityConnectionAliases) PageInfo(p graphql.ResolveParams) (interface{}, error) {
	val, err := graphql.DefaultResolver(p.Source, p.Info.FieldName)
	return val, err
}

// EntityConnectionType A connection to a sequence of records.
var EntityConnectionType = graphql.NewType("EntityConnection", graphql.ObjectKind)

// RegisterEntityConnection registers EntityConnection object type with given service.
func RegisterEntityConnection(svc *graphql.Service, impl EntityConnectionFieldResolvers) {
	svc.RegisterObject(_ObjectTypeEntityConnectionDesc, impl)
}
func _ObjTypeEntityConnectionNodesHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		Nodes(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.Nodes(frp)
	}
}

func _ObjTypeEntityConnectionPageInfoHandler(impl interface{}) graphql1.FieldResolveFn {
	resolver := impl.(interface {
		PageInfo(p graphql.ResolveParams) (interface{}, error)
	})
	return func(frp graphql1.ResolveParams) (interface{}, error) {
		return resolver.PageInfo(frp)
	}
}

func _ObjectTypeEntityConnectionConfigFn() graphql1.ObjectConfig {
	return graphql1.ObjectConfig{
		Description: "A connection to a sequence of records.",
		Fields: graphql1.Fields{
			"nodes": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "nodes",
				Type:              graphql1.NewNonNull(graphql1.NewList(graphql1.NewNonNull(graphql.OutputType("Entity")))),
			},
			"pageInfo": &graphql1.Field{
				Args:              graphql1.FieldConfigArgument{},
				DeprecationReason: "",
				Description:       "self descriptive",
				Name:              "pageInfo",
				Type:              graphql1.NewNonNull(graphql.OutputType("OffsetPageInfo")),
			},
		},
		Interfaces: []*graphql1.Interface{},
		IsTypeOf: func(_ graphql1.IsTypeOfParams) bool {
			// NOTE:
			// Panic by default. Intent is that when Service is invoked, values of
			// these fields are updated with instantiated resolvers. If these
			// defaults are called it is most certainly programmer err.
			// If you're see this comment then: 'Whoops! Sorry, my bad.'
			panic("Unimplemented; see EntityConnectionFieldResolvers.")
		},
		Name: "EntityConnection",
	}
}

// describe EntityConnection's configuration; kept private to avoid unintentional tampering of configuration at runtime.
var _ObjectTypeEntityConnectionDesc = graphql.ObjectDesc{
	Config: _ObjectTypeEntityConnectionConfigFn,
	FieldHandlers: map[string]graphql.FieldHandler{
		"nodes":    _ObjTypeEntityConnectionNodesHandler,
		"pageInfo": _ObjTypeEntityConnectionPageInfoHandler,
	},
}

// EntityListOrder Describes ways in which a list of entities can be ordered.
type EntityListOrder string

// EntityListOrders holds enum values
var EntityListOrders = _EnumTypeEntityListOrderValues{
	ID:       "ID",
	ID_DESC:  "ID_DESC",
	LASTSEEN: "LASTSEEN",
}

// EntityListOrderType Describes ways in which a list of entities can be ordered.
var EntityListOrderType = graphql.NewType("EntityListOrder", graphql.EnumKind)

// RegisterEntityListOrder registers EntityListOrder object type with given service.
func RegisterEntityListOrder(svc *graphql.Service) {
	svc.RegisterEnum(_EnumTypeEntityListOrderDesc)
}
func _EnumTypeEntityListOrderConfigFn() graphql1.EnumConfig {
	return graphql1.EnumConfig{
		Description: "Describes ways in which a list of entities can be ordered.",
		Name:        "EntityListOrder",
		Values: graphql1.EnumValueConfigMap{
			"ID": &graphql1.EnumValueConfig{
				DeprecationReason: "",
				Description:       "self descriptive",
				Value:             "ID",
			},
			"ID_DESC": &graphql1.EnumValueConfig{
				DeprecationReason: "",
				Description:       "self descriptive",
				Value:             "ID_DESC",
			},
			"LASTSEEN": &graphql1.EnumValueConfig{
				DeprecationReason: "no longer supported; required scan of entire entities keyspace, performed poorly",
				Description:       "self descriptive",
				Value:             "LASTSEEN",
			},
		},
	}
}

// describe EntityListOrder's configuration; kept private to avoid unintentional tampering of configuration at runtime.
var _EnumTypeEntityListOrderDesc = graphql.EnumDesc{Config: _EnumTypeEntityListOrderConfigFn}

type _EnumTypeEntityListOrderValues struct {
	// ID - self descriptive
	ID EntityListOrder
	// ID_DESC - self descriptive
	ID_DESC EntityListOrder
	// LASTSEEN - self descriptive
	LASTSEEN EntityListOrder
}
